"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = applyRules;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _utils = require("./utils");

var _runRules = require("./runRules");

var _runRules2 = _interopRequireDefault(_runRules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function applyRules(FormComponent) {
  var FormWithConditionals = function (_Component) {
    _inherits(FormWithConditionals, _Component);

    function FormWithConditionals(props) {
      _classCallCheck(this, FormWithConditionals);

      var _this = _possibleConstructorReturn(this, (FormWithConditionals.__proto__ || Object.getPrototypeOf(FormWithConditionals)).call(this, props));

      _initialiseProps.call(_this);

      var _this$props = _this.props,
          schema = _this$props.schema,
          uiSchema = _this$props.uiSchema,
          formData = _this$props.formData;

      _this.state = { schema: schema, uiSchema: uiSchema, formData: formData };

      _this.formData = formData;
      _this.handleChange({ formData: formData });
      return _this;
    }

    _createClass(FormWithConditionals, [{
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        var _this2 = this;

        var schema = nextProps.schema,
            uiSchema = nextProps.uiSchema,
            formData = nextProps.formData;

        if (!this.sameSchema(nextProps) || !this.sameFormData(nextProps)) {
          this.setState({ schema: schema, uiSchema: uiSchema, formData: formData }, function () {
            return _this2.handleChange({ formData: formData });
          });
        }
      }
    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        var sameData = this.sameFormData(nextProps);
        var sameState = (0, _deepEqual2.default)(nextState, this.state);
        var sameProps = (0, _deepEqual2.default)(Object.assign({}, this.props, { formData: this.formData }), nextProps);
        return !sameProps || !sameData || !sameState;
      }
    }, {
      key: "render",
      value: function render() {
        var configs = Object.assign({}, this.props, this.state, {
          onChange: this.handleChange
        });
        return _react2.default.createElement(FormComponent, configs);
      }
    }]);

    return FormWithConditionals;
  }(_react.Component);

  var _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.sameSchema = function (nextProps) {
      return (0, _deepEqual2.default)({ schema: nextProps.schema, uiSchema: nextProps.uiSchema }, { schema: _this3.props.schema, uiSchema: _this3.props.uiSchema });
    };

    this.sameFormData = function (nextProps) {
      return (0, _deepEqual2.default)(nextProps.formData, _this3.formData);
    };

    this.updateState = function (changedFormData, conf) {
      _this3.formData = conf.formData;
      var sameConf = (0, _deepEqual2.default)({ schema: conf.schema, uiSchema: conf.uiSchema }, { schema: _this3.state.schema, uiSchema: _this3.state.uiSchema });
      var sameForm = (0, _deepEqual2.default)(changedFormData, conf.formData);
      if (!sameConf || !sameForm) {
        _this3.setState(Object.assign({}, conf));
      }
    };

    this.handleChange = function (state) {
      var _state = state,
          formData = _state.formData;

      (0, _runRules2.default)(formData, _this3.props).then(function (conf) {
        _this3.updateState(formData, conf);
        if (_this3.props.onChange) {
          state = Object.assign({}, state, conf);
          _this3.props.onChange(state);
        }
      });
    };
  };

  if ((0, _utils.isDevelopment)()) {
    FormWithConditionals.propTypes = {
      rulesEngine: _propTypes2.default.func.isRequired,
      rules: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        conditions: _propTypes2.default.object.isRequired,
        order: _propTypes2.default.number,
        event: _propTypes2.default.shape({
          type: _propTypes2.default.string.isRequired
        })
      })).isRequired,
      extraActions: _propTypes2.default.object
    };
  }

  return FormWithConditionals;
}